<template>
  <GManageTable
    :card="card"
    :i18n-base="i18nBase"
    v-bind="$attrs"
    :headers="headers"
    :items="value.refTypeDefinition"
    use-wrapper
    :get-new-item="getNewItem"
    :optional="optional"
    :wiki-entry="wikiEntry"
    @create="create"
    @edit="edit"
    @remove="remove"
    @deleteElement="$emit('delete')"
  >
    <template #form="{ item, updateAvailableElements }">
      <RefTypeDefinition
        v-model="item.value"
        :update-available-elements="updateAvailableElements"
      />
    </template>

    <template #[`item.name`]="{ item }">
      {{ getForCurrentLocale(item.name) }}
    </template>
    <template #[`item.description`]="{ item }">
      <div class="text-truncate default-max-width">
        {{ getForCurrentLocale(item.description) }}
      </div>
    </template>
  </GManageTable>
</template>

<script>
import { RefTypeDefinitionType } from "@d-ptb/dcc-js";
import { validatableMixin } from "../../Mixins/validatableMixin";
import { removeFromArray } from "~/assets/util/general";
import GManageTable from "~/components/App/Common/ManagementTable/GManageTable.vue";
import { localizationMixin } from "~/components/Mixins/localizationMixin";
import RefTypeDefinition from "~/components/DCC/AdministrativeData/RefTypeDefinition.vue";

export default {
  name: "RefTypeDefinitionList",
  components: {
    RefTypeDefinition,
    GManageTable,
  },
  mixins: [validatableMixin, localizationMixin],
  props: {
    value: Object,
    i18nBase: {
      type: String,
      default: "dcc.common.refTypeDefinitionListType",
    },
    card: {
      type: Boolean,
      default: true,
    },
    optional: {
      type: Boolean,
      default: false,
    },
    wikiEntry: {
      type: String,
    },
  },
  data() {
    return {
      headers: [
        {
          text: this.$t("dcc.common.attributes.refType"),
          value: "_attr.refType",
        },
        {
          text: this.$t("dcc.common.refTypeDefinitionType.name"),
          value: "name",
        },
        {
          text: this.$t("dcc.common.refTypeDefinitionType.description.title"),
          value: "description",
          sortable: false,
        },
      ],
    };
  },
  computed: {
    customRules() {
      return [
        () =>
          this.value.refTypeDefinition.length > 0 ||
          this.$t(`${this.i18nBase}.empty`),
      ];
    },
  },
  watch: {
    "value.refTypeDefinition"() {
      this.validate();
    },
  },
  methods: {
    remove(item) {
      removeFromArray(this.value.refTypeDefinition, item);
    },
    create(item) {
      this.value.refTypeDefinition.push(new RefTypeDefinitionType(item));
    },
    edit(item, index) {
      this.$set(this.value.refTypeDefinition, index, undefined);
      this.$set(
        this.value.refTypeDefinition,
        index,
        new RefTypeDefinitionType(item)
      );
    },
    getNewItem() {
      return new RefTypeDefinitionType();
    },
  },
};
</script>
